CM.make("sources.cm");
CM.make("$/ml-yacc-lib.cm"); 

open NRC;
open Eval;

exception Error of string;

(* parsing functors argh *)
structure NrcLrVals = NrcLrValsFun(structure Token = LrParser.Token)
structure NrcLex = NrcLexFun(structure Tokens = 
                             NrcLrVals.Tokens)
structure NrcParser = 
  Join(structure ParserData = NrcLrVals.ParserData
    structure Lex=NrcLex
    structure LrParser=LrParser)

fun parse filename =
    let val _ = NrcLex.UserDeclarations.pos := 0
	val file = TextIO.openIn filename
	fun get _ = TextIO.input file
	fun parseerror(s,p1,p2) = raise (Error(s))
	val lexer = NrcParser.Stream.streamify (NrcLex.makeLexer get)
	val (Exp absyn, _) = NrcParser.parse(30,lexer,parseerror,())
    in TextIO.closeIn file;
	   absyn
    end handle LrParser.ParseError => raise ErrorMsg.Error
	
fun parse_string str =
    let fun get _ = str
	fun parseerror(s,p1,p2) = raise (Error(s))
	val lexer = NrcParser.Stream.streamify (NrcLex.makeLexer get)
	val (Exp absyn, _) = NrcParser.parse(30,lexer,parseerror,())
    in absyn
    end handle LrParser.ParseError => raise ErrorMsg.Error
	

val r = Var.mk_var "R";
val s = Var.mk_var "S";

val db = [(r,SetV[PairV(StringV "Mercury",IntV 3),
			PairV(StringV "Venus",IntV 4),
			PairV(StringV "Earth",IntV 6),
			PairV(StringV "Mars",IntV 5)]),
	  (s,SetV([PairV(StringV "Mars",PairV(StringV "The Moon",IntV 9)),
		   PairV(StringV "Earth",PairV(StringV "Phobos",IntV 7)),
		   PairV(StringV "Mars",PairV(StringV "Deimos",IntV 5))]))];

val ty = [(r,SetTy(PairTy(StringTy,IntTy))),
          (s,SetTy(PairTy(StringTy,PairTy(StringTy,IntTy))))]
val ctx = List.foldr Var.Map.insert' Var.Map.empty db;
val tyctx = List.foldr Var.Map.insert' Var.Map.empty ty;
