structure Record = struct
  
  type 'a record = (string * 'a) list
		   
  fun lookup x ((x',y)::l)  =  if x = x' then y else lookup x l;;
						     
  fun equiv equiv (r1, r2) = 
      length r1 = length r2 
      andalso List.all (fn (f,x) => equiv (x, lookup f r2 )) r1
      handle _ => false
		  
  fun map f r = List.map (fn (a,x) => (a,f x)) r
  fun fmap f r = List.map (fn (a,x) => (a,f(a,x))) r
		
(* TODO: Make order insensitive *)
  fun merge m ([], []) = []
    | merge m ((f,x)::r,(g,y)::s) =
      if f = g then (f,m(x,y))::(merge m (r,s))
      else raise Match
      
  fun toString aToString r = 
      let fun toS [] = ""
	    | toS [(f,x)] = f^":"^(aToString x)
	    | toS ((f,x)::r) =  f^":"^(aToString x)^","^toS r
      in toS r
      end
      
end
