functor Tagged2Table(structure TaggedValue : TAGGED_VALUE) = 
struct

  open TaggedValue.Tag;
  open TaggedValue;
  structure T = NRC;
  open Html;

  fun  span_id_tag t h = 
       case Tag.listItems(t) 
	of [i] => E(span_id(i), h)
	 | _   => E(span,h)
  fun  tr_id_tag t h = 
       case Tag.listItems(t) 
	of [i] => E((TR,[("id",i)]), h)
	 | _   => E((TR,[]),h)
  
  fun ty2headrow (rty) = [tr (List.map (fn (f,ty) => th [S f]) rty)]

	  
  fun tag2table (Tag(t,c),ty) = [span_id_tag t (raw2table(c,ty))]
  and raw2table(SetV(records),T.SetTy(T.RecordTy record_ty)) = 
      let val headrow = ty2headrow record_ty
          fun tag2row (Tag(t,RecordV row),rty) = 
              tr_id_tag t (List.map (fn (f,ty) => td (tag2table (Record.lookup f row, ty))) record_ty)
          val rows = List.map (fn row => tag2row(row,record_ty)) records
      in
          [E(table_border "1", 
             (headrow @ rows))]
      end
    | raw2table(IntV i, T.IntTy) = [S (Int.toString(i))]
    | raw2table(BoolV(v),T.BoolTy) =  [S (if v then "true" else "false")]
    | raw2table(StringV(v),T.StringTy) = [S v]

	  

  fun ty_level (IntV _) = 2
    | ty_level (StringV _) = 2
    | ty_level (BoolV _) = 2
    | ty_level (PairV (_,_)) = 1
    | ty_level (SetV _) = 0
    | ty_level (RecordV _) = 1

  fun color_level 0 = "'#FFBFBF'"
    | color_level 1 = "'#FF7F7F'"
    | color_level 2 = "'#FF0000'"


  fun span_ref_hilite tag xs color = 

      let val tags = List.map (fn x => "'"^x^"'") (Tag.listItems tag)
	  val tag_arr = 
	      "new Array("^(String.concatWith "," tags)^")"
      in 
      E((SPAN,[("onMouseOver",
		"setBgColors("^tag_arr^","^color^");"^
		"this.style.backgroundColor="^color^";"),
	       ("onMouseOut",
		"setBgColors("^tag_arr^",'transparent');"^
		"this.style.backgroundColor='transparent';")]),
	xs)
      end

  fun tr_ref_hilite tag xs color = 

      let val tags = List.map (fn x => "'"^x^"'") (Tag.listItems tag)
	  val tag_arr = 
	      "new Array("^(String.concatWith "," tags)^")"
      in 
      E((TR,[("onMouseOver",
		"setBgColors("^tag_arr^","^color^");"^
		"this.style.backgroundColor="^color^";"),
	       ("onMouseOut",
		"setBgColors("^tag_arr^",'transparent');"^
		"this.style.backgroundColor='transparent';")]),
	xs)
      end

(* Builds table that refers to existing table *)

  fun tag2tableref (Tag(t,c),ty) = 
      [span_ref_hilite t (raw2tableref(c,ty)) (color_level (ty_level c))]
  and raw2tableref(SetV(records),T.SetTy(T.RecordTy record_ty)) = 
      [E(table_border "1", (ty2headrow (record_ty) 
			    @ List.map 
				  (fn row => tag2rowref(row,record_ty)) 
				  records))]
    | raw2tableref(IntV i, T.IntTy) = [S (Int.toString(i))]
    | raw2tableref(BoolV(v),T.BoolTy) =  [S (if v then "true" else "false")]
    | raw2tableref(StringV(v),T.StringTy) = [S v]

  and tag2rowref (Tag(t,RecordV row),rty) = 
      tr_ref_hilite t (List.map (fn (f,ty) => td (tag2tableref (Record.lookup f row, ty))) rty) (color_level 1)


fun find x ((x',y)::l)  =  if Tag.equal(x,x') then y else find x l;;



fun tag2tableref_map m (t,ty) = 
  let fun tag2tr (Tag(t,c),ty) = 
	  let val ts = find t m
	  in 
	      [span_ref_hilite ts (raw2tr (c,ty)) (color_level (ty_level c))]
	  end
      and raw2tr(SetV(records),T.SetTy(T.RecordTy record_ty)) = 
	  [E(table_border "1", (ty2headrow (record_ty) 
				@ List.map 
				      (fn row => tag2rr(row,record_ty)) 
				      records))]
	| raw2tr (IntV i, T.IntTy) = [S (Int.toString(i))]
	| raw2tr (BoolV(v),T.BoolTy) =  [S (if v then "true" else "false")]
	| raw2tr (StringV(v),T.StringTy) = [S v]
					  
      and tag2rr (Tag(t,RecordV row), rty) = 
	  let val ts = find t m
	  in 
	      tr_ref_hilite t 
			(List.map 
			     (fn (f,ty) => td (tag2tr (Record.lookup f row, ty))) rty) 
			(color_level 1)
	  end
  in tag2tr (t,ty)
  end
      
      

end
