signature TAGGED_TYPE = sig
    structure Tag : TAG;
    datatype raw_type = IntTy
                    | BoolTy
		    | StringTy
                    | PairTy of tag_type * tag_type
		    | SetTy of tag_type
		    | RecordTy of tag_type Record.record
	 and tag_type = Tag of {tag:Tag.tag,con: raw_type}
			    
    val notag : raw_type -> tag_type
    val tag : raw_type -> tag_type
    val addtag : tag_type * Tag.tag -> tag_type

    val mk_empty_ty : NRC.ty -> tag_type
    val mk_tagged_ty : NRC.ty -> tag_type

    val erase : tag_type -> NRC.ty
    val equiv : (tag_type * tag_type) -> bool
    val merge : (tag_type * tag_type) -> tag_type
    val prov : tag_type -> Tag.tag
    val toString : tag_type -> string
    val simplify : tag_type -> tag_type
			       
end
