functor TaggedType2HiliteFun(structure TaggedType : TAGGED_TYPE) = struct

  open TaggedType.Tag;
  open TaggedType;
  open Html;

  fun tt2base (Tag{tag=s,con=rt}) = 
      case Tag.listItems s 
       of [i] => [E(span_id(i), rt2base(rt))]
	| _ => [E(span,rt2base(rt))]
  and rt2base (IntTy) = [S "int"] 
    | rt2base (BoolTy) = [S "bool"]
    | rt2base (StringTy) = [S "string"]
    | rt2base (PairTy(ty1,ty2)) = [S "("]@tt2base(ty1) @ [S " * "] @ tt2base (ty2) @[S ")"]
    | rt2base (SetTy(ty)) = [S "{"]@tt2base(ty)@[S "}"]
    | rt2base (RecordTy(ty)) = [S "&lt;"]@tt2base_record ty@[S "&gt;"]
  and tt2base_record [] = []
    | tt2base_record [(f,x)] = [S (f^":")]@tt2base x
    | tt2base_record ((f,x)::rty) = [S (f^":")]@tt2base x @[S ","]@tt2base_record rty

  fun ty (IntTy) = 2
    | ty (StringTy) = 2
    | ty (BoolTy) = 2
    | ty (PairTy (_,_)) = 1
    | ty (SetTy _) = 0
    | ty (RecordTy _) = 1

  fun color_level 0 = "'#FFBFBF'"
    | color_level 1 = "'#FF7F7F'"
    | color_level 2 = "'#FF0000'"

  fun ref_hilite tag xs color = 

      let val tags = List.map (fn x => "'"^x^"'") (Tag.listItems tag)
	  val tag_arr = 
	      "new Array("^(String.concatWith "," tags)^")"
      in 
      E((SPAN,[("onMouseOver",
		"setBgColors("^tag_arr^","^color^");"^
		"this.style.backgroundColor="^color^";"),
	       ("onMouseOut",
		"setBgColors("^tag_arr^",'transparent');"^
		"this.style.backgroundColor='transparent';")]),
	xs)
      end 

  fun tt2ref (Tag{tag=t,con=c}) = 
      [ref_hilite t (rt2ref c) (color_level (ty c))]
  and rt2ref IntTy = [S "int"]
    | rt2ref StringTy = [S "string"]
    | rt2ref BoolTy =  [S "bool"]
    | rt2ref (SetTy(ty)) = [S "{"]@tt2ref(ty)@[S "}"]
    | rt2ref (PairTy(ty1,ty2)) = [S "("]@tt2ref ty1 @ [S "*"]@ tt2ref ty2 @[S ")"]
    | rt2ref (RecordTy(ty)) = [S "&lt;"]@tt2ref_record ty@[S "&gt;"]
  and tt2ref_record [] = []
    | tt2ref_record [(f,x)] = [S (f^":")]@tt2ref x
    | tt2ref_record ((f,x)::rty) = [S (f^":")]@tt2ref x @[S ","]@tt2ref_record rty
  
      



end


