functor TaggedType2HtmlFun(structure TaggedType : TAGGED_TYPE) = struct

  open TaggedType.Tag;
  open TaggedType;
  open Html;
  fun links2hrefs ([]) = []
    | links2hrefs ([v]) = 
      [E(a_href("#"^(v)),[S(v)])]
    | links2hrefs (v::vs) = 
      [E(a_href("#"^(v)),[S(v)]),
       S(",")]@(links2hrefs(vs))


  fun tt2base (Tag{tag=s,con=rt}) = 
      case Tag.listItems s 
       of [i] => [E(a_name(i), rt2base(rt)@[E(sup,links2hrefs [i])])]
	| _ => rt2base(rt)
  and rt2base (IntTy) = [S "int"] 
    | rt2base (BoolTy) = [S "bool"]
    | rt2base (StringTy) = [S "string"]
    | rt2base (PairTy(ty1,ty2)) = [S "("]@tt2base(ty1) @ [S " * "] @ tt2base (ty2) @[S ")"]
    | rt2base (SetTy(ty)) = [S "{"]@tt2base(ty)@[S "}"]
    | rt2base (RecordTy(ty)) = [S "&lt;"]@tt2base_record ty@[S "&gt;"]
  and tt2base_record [] = []
    | tt2base_record [(f,x)] = [S (f^":")]@tt2base x
    | tt2base_record ((f,x)::rty) = [S (f^":")]@tt2base x @[S ","]@tt2base_record rty

 

  fun tt2ref (Tag{tag=t,con=c}) = 
      rt2ref(c)@[E(sup,links2hrefs (Tag.listItems t))]
  and rt2ref IntTy = [S "int"]
    | rt2ref StringTy = [S "string"]
    | rt2ref BoolTy =  [S "bool"]
    | rt2ref (SetTy(ty)) = [S "{"]@tt2ref(ty)@[S "}"]
    | rt2ref (PairTy(ty1,ty2)) = [S "("]@tt2ref ty1 @ [S "*"]@ tt2ref ty2 @[S ")"]
    | rt2ref (RecordTy(ty)) = [S "&lt;"]@tt2ref_record ty@[S "&gt;"]
  and tt2ref_record [] = []
    | tt2ref_record [(f,x)] = [S (f^":")]@tt2ref x
    | tt2ref_record ((f,x)::rty) = [S (f^":")]@tt2ref x @[S ","]@tt2ref_record rty
  
      


end


