signature TAGGED_VALUE = sig
    structure Tag : TAG;

  datatype raw_value = BoolV of bool
		     | IntV of int
		     | StringV of string
		     | PairV of tag_value * tag_value
		     | SetV of tag_value list
		     | RecordV of tag_value Record.record
       and tag_value = Tag of Tag.tag * raw_value

  val mk_tagged_value : Value.value -> tag_value;
  val mk_atomic_tagged_value : Value.value -> tag_value;
  val mk_row_tagged_value : Value.value -> tag_value;
  val erase : tag_value -> Value.value;
  val eq : tag_value * tag_value -> bool;
  val prov : tag_value -> Tag.tag;
  val toString : tag_value -> string;
  val simplify : tag_value -> tag_value;
  val tagOf : tag_value -> Tag.tag;
  val addtag : tag_value * Tag.tag -> tag_value;
  val notag : raw_value -> tag_value;
  val tag_extract : tag_value -> tag_value * (Tag.tag * Tag.tag) list
end
