functor TaggedValue2HiliteFun(structure TaggedValue : TAGGED_VALUE) = 
struct

  open TaggedValue.Tag;
  open TaggedValue;
  open Html;

  fun tv2base (Tag(t,c)) = 
      case Tag.listItems(t) 
       of [i] => [E(span_id(i), rv2base(c))]
	| _   => [E(span,rv2base(c))]
  and rv2base (IntV(v))      = [S (Int.toString(v))]
    | rv2base (StringV(v))   = [S v]
    | rv2base (BoolV(v))     = [S (if v then "true" else "false")]
    | rv2base (PairV(v1,v2)) = [S "("] @ tv2base(v1) @ [S " , "] @ tv2base (v2)@ [S ")"]
    | rv2base (RecordV(vs)) = tv2base_record vs
    | rv2base (SetV(vs))     = 
      [E((TABLE, [("border","1"),("cellpadding","2")]),
	       (List.map (fn v => tr(List.map td'(tv2base v))) vs))]
  and tv2base_record [] = []
    | tv2base_record [(f,x)] = tv2base(x)
    | tv2base_record ((f,x)::r) = tv2base(x)@ [S ","] @ tv2base_record (r)
	 


  fun ref_hilite tag xs color = 

      let val tags = List.map (fn x => "'"^x^"'") (Tag.listItems tag)
	  val tag_arr = 
	      "new Array("^(String.concatWith "," tags)^")"
      in 
      E((SPAN,[("onMouseOver",
		"setBgColors("^tag_arr^","^color^");"^
		"this.style.backgroundColor="^color^";"),
	       ("onMouseOut",
		"setBgColors("^tag_arr^",'transparent');"^
		"this.style.backgroundColor='transparent';")]),
	xs)
      end

  fun ty (IntV _) = 2
    | ty (StringV _) = 2
    | ty (BoolV _) = 2
    | ty (PairV (_,_)) = 1
    | ty (SetV _) = 0
    | ty (RecordV _) = 1

  fun color_level 0 = "'#FFBFBF'"
    | color_level 1 = "'#FF7F7F'"
    | color_level 2 = "'#FF0000'"

  fun tv2ref (Tag(t,c)) = [ref_hilite t (rv2ref c) (color_level (ty c))]

  and rv2ref (IntV(v)) = [S (Int.toString(v))]
    | rv2ref (StringV(v)) = [S v]
    | rv2ref (BoolV(v)) =  [S (if v then "true" else "false")]
    | rv2ref (PairV(v1,v2)) = [S "("] @ tv2ref(v1) @ [S " , "] @tv2ref (v2) @ [S ")"]
    | rv2ref (SetV(vs)) = 
      [E((TABLE, [("border","1"),("cellpadding","2")]),
	 (List.map (fn v => tr(List.map td' (tv2ref v))) vs))]
    | rv2ref (RecordV(vs)) = tv2ref_record vs
  and tv2ref_record [] = []
    | tv2ref_record [(f,x)] = tv2ref(x)
    | tv2ref_record ((f,x)::r) = tv2ref(x)@ [S ","] @ tv2ref_record (r)

end
