functor TaggedValue2HtmlFun(structure TaggedValue : TAGGED_VALUE) = 
struct

  open TaggedValue.Tag;
  open TaggedValue;
  open Html;


  fun links2hrefs ([]) = []
    | links2hrefs ([v]) = 
      [E(a_href("#"^(v)),[S(v)])]
    | links2hrefs (v::vs) = 
      [E(a_href("#"^(v)),[S(v)]),
       S(",")]@(links2hrefs(vs))


  fun tv2base (Tag(t,c)) = 
      case Tag.listItems(t) 
       of [i] =>  
	  [E(a_name(i),
	     rv2base(c)
		      @[E(sup,links2hrefs (Tag.listItems t))])]
	| _ => [E(span,rv2base(c))]
  and rv2base (IntV(v)) = [S (Int.toString(v))]
    | rv2base (StringV(v)) = [S v]
    | rv2base (BoolV(v)) =  [S (if v then "true" else "false")]
    | rv2base (PairV(v1,v2)) = tv2base(v1) @ [S ","] @ tv2base (v2)
    | rv2base (RecordV(vs)) = tv2base_record vs
    | rv2base (SetV(vs)) = 
      [E(table_border "1",
	       (List.map (fn v => tr(List.map td'(tv2base v))) vs))]
  and tv2base_record [] = []
    | tv2base_record [(f,x)] = tv2base(x)
    | tv2base_record ((f,x)::r) = tv2base(x)@ [S ","] @ tv2base_record (r)


  fun tv2ref (Tag(t,c)) = [E(span,rv2ref c@[E(sup,links2hrefs (Tag.listItems t))])]

  and rv2ref (IntV(v)) = [S (Int.toString(v))]
    | rv2ref (StringV(v)) = [S v]
    | rv2ref (BoolV(v)) =  [S (if v then "true" else "false")]
    | rv2ref (PairV(v1,v2)) = tv2ref(v1) @ [S ","] @tv2ref (v2)
    | rv2ref (SetV(vs)) = 
      [E(table_border "1",
	 (List.map (fn v => tr(List.map td'(tv2ref v))) vs))]
    | rv2ref (RecordV(vs)) = tv2ref_record vs
  and tv2ref_record [] = []
    | tv2ref_record [(f,x)] = tv2ref(x)
    | tv2ref_record ((f,x)::r) = tv2ref(x)@ [S ","] @ tv2ref_record (r)


end
