CM.make("sources.cm");
(* seems necessary  even though should be loaded from sources.cm *)CM.make("$/ml-yacc-lib.cm"); 


open NRC;
open Eval;
exception Error of string;

(* parsing functors argh *)
structure NrcLrVals = NrcLrValsFun(structure Token = LrParser.Token)
structure NrcLex = NrcLexFun(structure Tokens = 
                             NrcLrVals.Tokens)
structure NrcParser = 
  Join(structure ParserData = NrcLrVals.ParserData
    structure Lex=NrcLex
    structure LrParser=LrParser)

structure Tag = SetTag;

structure TaggedValue = TaggedValueFun(structure Tag = Tag);
structure TaggedEval = TaggedEvalFun(structure TaggedValue = TaggedValue);
structure TaggedValue2Html = 
  TaggedValue2HiliteFun(structure TaggedValue = TaggedValue);

structure TaggedType = TaggedTypeFun(structure Tag = Tag);
structure TaggedTypeAnalyze = TaggedTypeAnalyzeFun(structure TaggedType = TaggedType);
structure TaggedType2Html = TaggedType2HiliteFun(structure TaggedType = TaggedType);

structure Tagged2Table = 
  Tagged2Table(structure TaggedValue = TaggedValue 
               structure TaggedType = TaggedType);

val bgColorScript = 
"<script> "^
"function setBgColor (id, color) { "^
"   if (document.layers) "^
"document[id].bgColor = color == 'transparent' ? null : color; "^
"  else if (document.all) "^
"    document.all[id].style.backgroundColor = color; "^
"  else if (document.getElementById) "^
"    document.getElementById(id).style.backgroundColor = color;" ^
"} "^
"function setBgColors (id_arr, color) { "^
"        for (var i=0;i<id_arr.length;i++) {"^
"                setBgColor(id_arr[i],color); "^
"        }"^
"} "^
"</script>";

fun parse filename =
    let val _ = NrcLex.UserDeclarations.pos := 0
	val file = TextIO.openIn filename
	fun get _ = TextIO.input file
	fun parseerror(s,p1,p2) = raise (Error(s))
	val lexer = NrcParser.Stream.streamify (NrcLex.makeLexer get)
	val (Exp absyn, _) = NrcParser.parse(30,lexer,parseerror,())
    in TextIO.closeIn file;
	   absyn
    end handle LrParser.ParseError => raise ErrorMsg.Error
	
fun parse_string str =
    let fun get _ = str
	fun parseerror(s,p1,p2) = raise (Error(s))
	val lexer = NrcParser.Stream.streamify (NrcLex.makeLexer get)
	val (Exp absyn, _) = NrcParser.parse(30,lexer,parseerror,())
    in absyn
    end handle LrParser.ParseError => raise ErrorMsg.Error
					    

(*
val r = Var.mk_var "R";
val s = Var.mk_var "S";


val db = [(r,SetV[PairV(IntV 1,IntV 2),
		   PairV(IntV 2,IntV 4),
		   PairV(IntV 3,IntV 5),
		   PairV(IntV 1,IntV 6),
                   PairV(IntV 1,IntV 2),
		   PairV(IntV 12,IntV 14),
		   PairV(IntV 13,IntV 15),
		   PairV(IntV 11,IntV 16),
                   PairV(IntV 12,IntV 14),
		   PairV(IntV 13,IntV 55),
		   PairV(IntV 21,IntV 56),
                   PairV(IntV 21,IntV 52),
		   PairV(IntV 22,IntV 54),
		   PairV(IntV 23,IntV 55),
		   PairV(IntV 21,IntV 46),
                   PairV(IntV 31,IntV 42),
		   PairV(IntV 32,IntV 44),
		   PairV(IntV 33,IntV 45),
		   PairV(IntV 31,IntV 46)]),
	  (s,SetV([PairV(IntV 1,IntV 2),
		   PairV(IntV 2,IntV 42),
		   PairV(IntV 3,IntV 5),
		   PairV(IntV 4,IntV 56),
                   PairV(IntV 11,IntV 52),
		   PairV(IntV 12,IntV 142),
		   PairV(IntV 13,IntV 15),
		   PairV(IntV 14,IntV 16),
                   PairV(IntV 11,IntV 22),
		   PairV(IntV 22,IntV 242),
		   PairV(IntV 23,IntV 25),
		   PairV(IntV 24,IntV 32),
		   PairV(IntV 22,IntV 342),
		   PairV(IntV 33,IntV 35),
		   PairV(IntV 34,IntV 46),
                   PairV(IntV 31,IntV 42),
		   PairV(IntV 32,IntV 442),
		   PairV(IntV 33,IntV 55),
		   PairV(IntV 44,IntV 56),
                   PairV(IntV 443, IntV 517)]))];
val ty = [(r,SetTy(PairTy(IntTy,IntTy))),
          (s,SetTy(PairTy(IntTy,IntTy)))]
val ctx = List.foldr Var.Map.insert' Var.Map.empty db;
val tyctx = List.foldr Var.Map.insert' Var.Map.empty ty;
val tctx = Var.Map.map TaggedValue.mk_atomic_tagged_value ctx;
val ttyctx = Var.Map.map TaggedType.mk_tagged_ty tyctx;
fun query ctx file = 
    let val e = parse file 
	val e' = Simplify.simplify e
        val ty = infer_ty (tyctx,e')
	val r = eval ctx ( e') 
	val tty = TaggedTypeAnalyze.analyze_prov(ttyctx,e)
    in print ((Value.toString r)^"\n");
       print ((TaggedType.toString tty)^"\n");
       r
    end;

fun tagged_query tctx file = 
    let 
        val e = parse file 
	val r = TaggedEval.eval tctx e 
    in print ((TaggedValue.toString r)^"\n");
       r
    end;
fun tagged_type ttyctx file = 
    let 
        val e = parse file 
	val tty = TaggedTypeAnalyze.analyze_prov (ttyctx, e)
    in print ((TaggedType.toString tty)^"\n");
       tty
    end;
(* <R,S> *)
query ctx "tests/test0.nrc";
tagged_query tctx "tests/test0.nrc";

(* U{U{if (snd(y)) = (fst(z))
    then {<fst(y),snd(z)>}
    else {}
    | z <- S}
  | y <- R} 
*)
query ctx "tests/test1.nrc";
tagged_query tctx "tests/test1.nrc";

(* sum{fst(y) | y <- R} *)
query ctx "tests/test2.nrc";
tagged_query tctx "tests/test2.nrc";

(* U{if (fst(y)) = 1 then {snd(y)} else {}
    | y <- R u S}
*)
query ctx "tests/test3.nrc";
tagged_query tctx "tests/test3.nrc";

(*
let W = R u S in
{<fst t,
  sum (U{if (fst(t)) = (fst(w)) then {snd w} else {} 
          | w <- W})> 
  | t <- W}
*)
query ctx "tests/test4.nrc";
tagged_query tctx "tests/test4.nrc";


fun makehtml root msg = 
    let val str = TextIO.openOut (root^".html")
    in 
	TextIO.output(str,"<html><head><title>Test</title>"^bgColorScript^"</head><body>"
			  ^msg^"<br />"
                          ^"<table border='1' align='top'><tr><td>R</td><td>S</td><td>Q(R,S)</td></tr> "
                          ^"<tr><td>"^(Html.htmlsToString (TaggedType2Html.tt2base(tagged_type ttyctx "tests/testr.nrc")))^"</td>"
			  ^"<td>"^(Html.htmlsToString (TaggedType2Html.tt2base(tagged_type ttyctx "tests/tests.nrc")))^"</td>"
			  
			  ^"<td>"^(Html.htmlsToString (TaggedType2Html.tt2ref(tagged_type ttyctx ("tests/"^root^".nrc"))))^"</td></tr>"
                          ^"<tr><td>"^(Html.htmlsToString (TaggedValue2Html.tv2base(tagged_query tctx "tests/testr.nrc")))^"</td>"
			  ^"<td>"^(Html.htmlsToString (TaggedValue2Html.tv2base(tagged_query tctx "tests/tests.nrc")))^"</td>"
			  
			  ^"<td>"^(Html.htmlsToString (TaggedValue2Html.tv2ref(tagged_query tctx ("tests/"^root^".nrc"))))^"</td></tr></table></body>");
	TextIO.closeOut(str)
    end
;


print "Making test1.html\n";
makehtml "test1" ("<code> U{U{if (snd(y)) = (fst(z)) then {&lt;fst(y),snd(z)&gt;} else {} | z <- S} | y <- R} </code>");
print "Making test2.html\n";
makehtml "test2" ("<code>sum{fst(y) | y <- R}</code>"); 
print "Making test3.html\n";
makehtml "test3" ("<code>U{if (fst(y)) = 1 then {snd(y)} else {} | y <- R u S}</code>");
print "Making test4.html\n";
makehtml "test4" ("<code>let W = R u S in {&lt;fst t,   sum (U{if (fst(t)) = (fst(w)) then {snd w} else {} | w <- W})&gt; | t <- W}</code>");
print "Making test5.html\n";
makehtml "test5" ("<code></code>");
print "Making test6.html\n";
makehtml "test6" ("<code></code>");




val r = Var.mk_var "R";
val s = Var.mk_var "S";

val db = [(r,SetV[PairV(StringV "Mercury",IntV 3),
			PairV(StringV "Venus",IntV 4),
			PairV(StringV "Earth",IntV 6),
			PairV(StringV "Mars",IntV 5)]),
	  (s,SetV([PairV(StringV "Mars",PairV(StringV "The Moon",IntV 9)),
		   PairV(StringV "Earth",PairV(StringV "Phobos",IntV 7)),
		   PairV(StringV "Mars",PairV(StringV "Deimos",IntV 5))]))];

val ty = [(r,SetTy(PairTy(StringTy,IntTy))),
          (s,SetTy(PairTy(StringTy,PairTy(StringTy,IntTy))))]
val ctx = List.foldr Var.Map.insert' Var.Map.empty db;
val tyctx = List.foldr Var.Map.insert' Var.Map.empty ty;
val tctx = Var.Map.map TaggedValue.mk_atomic_tagged_value ctx;
val ttyctx = Var.Map.map TaggedType.mk_tagged_ty tyctx;
fun query ctx file = 
    let val e = parse file 
        val ty = infer_ty (tyctx,e)
	val r = eval ctx (e )
	val tty = TaggedTypeAnalyze.analyze_prov(ttyctx,e)
    in print ((Value.toString r)^"\n");
       print ((TaggedType.toString tty)^"\n");
       r
    end;

fun tagged_query tctx file = 
    let 
        val e = parse file 
	val r = TaggedEval.eval tctx e 
    in print ((TaggedValue.toString r)^"\n");
       TaggedValue.simplify  (r)
    end;
fun tagged_type ttyctx file = 
    let 
        val e = parse file 
	val tty = TaggedTypeAnalyze.analyze_prov (ttyctx, e)
    in print ((TaggedType.toString tty)^"\n");
       TaggedType.simplify tty
    end;
fun makehtml root msg = 
    let val str = TextIO.openOut (root^".html")
    in 
	TextIO.output(str,"<html><head><title>Test</title>"^bgColorScript^"</head><body>"
			  ^msg^"<br />"
                          ^"<table border='1' align='top'><tr><td>R</td><td>S</td><td>Q</td></tr> "
                          ^"<tr><td>"^(Html.htmlsToString (TaggedType2Html.tt2base(tagged_type ttyctx "tests/testr.nrc")))^"</td>"
			  ^"<td>"^(Html.htmlsToString (TaggedType2Html.tt2base(tagged_type ttyctx "tests/tests.nrc")))^"</td>"
			  
			  ^"<td>"^(Html.htmlsToString (TaggedType2Html.tt2ref(tagged_type ttyctx ("tests/"^root^".nrc"))))^"</td></tr>"
                          ^"<tr><td>"^(Html.htmlsToString (TaggedValue2Html.tv2base(tagged_query tctx "tests/testr.nrc")))^"</td>"
			  ^"<td>"^(Html.htmlsToString (TaggedValue2Html.tv2base(tagged_query tctx "tests/tests.nrc")))^"</td>"
			  
			  ^"<td>"^(Html.htmlsToString (TaggedValue2Html.tv2ref(tagged_query tctx ("tests/"^root^".nrc"))))^"</td></tr></table></body>");
	TextIO.closeOut(str)
    end
;

print "Making test7.html\n";
makehtml "test7" ("");

print "Making test8.html\n";
makehtml "test8" ("");



val r = Var.mk_var "R";
val s = Var.mk_var "S";

val db = [(r,SetV[PairV(IntV 1,IntV 1),
			PairV(IntV 1,IntV 2),
			PairV(IntV 2,IntV 3),
	  PairV(IntV 2, IntV 2)]),
	  (s,SetV([PairV(IntV 1,PairV(IntV 2,IntV 3)),
		   PairV(IntV 1,PairV(IntV 1,IntV 4))]))];

val ty = [(r,SetTy(PairTy(IntTy,IntTy))),
          (s,SetTy(PairTy(IntTy,PairTy(IntTy,IntTy))))]
val ctx = List.foldr Var.Map.insert' Var.Map.empty db;
val tyctx = List.foldr Var.Map.insert' Var.Map.empty ty;
val tctx = Var.Map.map TaggedValue.mk_atomic_tagged_value ctx;
val ttyctx = Var.Map.map TaggedType.mk_tagged_ty tyctx;
fun query ctx file = 
    let val e = parse file 
        val ty = infer_ty (tyctx,e)
	val r = eval ctx ( e) 
	val tty = TaggedTypeAnalyze.analyze_prov(ttyctx,e)
    in print ((Value.toString r)^"\n");
       print ((TaggedType.toString tty)^"\n");
       r
    end;

fun tagged_query tctx file = 
    let 
        val e = parse file 
	val r = TaggedEval.eval tctx e 
    in print ((TaggedValue.toString r)^"\n");
       TaggedValue.simplify (r)
    end;
fun tagged_type ttyctx file = 
    let 
        val e = parse file 
	val tty = TaggedTypeAnalyze.analyze_prov (ttyctx, e)
    in print ((TaggedType.toString tty)^"\n");
       TaggedType.simplify tty
    end;
fun makehtml root msg = 
    let val str = TextIO.openOut (root^".html")
    in 
	TextIO.output(str,"<html><head><title>Test</title>"^bgColorScript^"</head><body>"
			  ^msg^"<br />"
                          ^"<table border='1' align='top'><tr><td>R</td><td>S</td><td>Q</td></tr> "
                          ^"<tr><td>"^(Html.htmlsToString (TaggedType2Html.tt2base(tagged_type ttyctx "tests/testr.nrc")))^"</td>"
			  ^"<td>"^(Html.htmlsToString (TaggedType2Html.tt2base(tagged_type ttyctx "tests/tests.nrc")))^"</td>"
			  
			  ^"<td>"^(Html.htmlsToString (TaggedType2Html.tt2ref(tagged_type ttyctx ("tests/"^root^".nrc"))))^"</td></tr>"
                          ^"<tr><td>"^(Html.htmlsToString (TaggedValue2Html.tv2base(tagged_query tctx "tests/testr.nrc")))^"</td>"
			  ^"<td>"^(Html.htmlsToString (TaggedValue2Html.tv2base(tagged_query tctx "tests/tests.nrc")))^"</td>"
			  
			  ^"<td>"^(Html.htmlsToString (TaggedValue2Html.tv2ref(tagged_query tctx ("tests/"^root^".nrc"))))^"</td></tr></table></body>");
	TextIO.closeOut(str)
    end
;

print "Making paper1.html\n";
makehtml "paper1" ("");

print "Making paper2.html\n";
makehtml "paper2" ("");

print "Making paper3.html\n";
makehtml "paper3" ("");

print "Making paper4.html\n";
makehtml "paper4" ("");
print "Making paper5.html\n";
makehtml "paper5" ("");
print "Making paper6.html\n";
makehtml "paper6" ("");
print "Making paper7.html\n";
makehtml "paper7" ("");
print "Making paper8.html\n";
makehtml "paper8" ("");

*)






val r = Var.mk_var "R";
val s = Var.mk_var "S";

val db = [(r,SetV[PairV(StringV "Mercury",IntV 3),
			PairV(StringV "Venus",IntV 4),
			PairV(StringV "Earth",IntV 6),
			PairV(StringV "Mars",IntV 5)]),
	  (s,SetV([PairV(StringV "Mars",PairV(StringV "The Moon",IntV 9)),
		   PairV(StringV "Earth",PairV(StringV "Phobos",IntV 7)),
		   PairV(StringV "Mars",PairV(StringV "Deimos",IntV 5))]))];

val ty = [(r,SetTy(PairTy(StringTy,IntTy))),
          (s,SetTy(PairTy(StringTy,PairTy(StringTy,IntTy))))]
val ctx = List.foldr Var.Map.insert' Var.Map.empty db;
val tyctx = List.foldr Var.Map.insert' Var.Map.empty ty;
val tctx = Var.Map.map TaggedValue.mk_atomic_tagged_value ctx;
val ttyctx = Var.Map.map TaggedType.mk_tagged_ty tyctx;
fun query ctx file = 
    let val e = parse file 
        val ty = infer_ty (tyctx,e)
	val r = eval ctx (e )
	val tty = TaggedTypeAnalyze.analyze_prov(ttyctx,e)
    in print ((Value.toString r)^"\n");
       print ((TaggedType.toString tty)^"\n");
       r
    end;

fun tagged_query tctx file = 
    let 
        val e = parse file 
	val r = TaggedEval.eval tctx e 
    in print ((TaggedValue.toString r)^"\n");
       TaggedValue.simplify  (r)
    end;
fun tagged_type ttyctx file = 
    let 
        val e = parse file 
	val tty = TaggedTypeAnalyze.analyze_prov (ttyctx, e)
    in print ((TaggedType.toString tty)^"\n");
       TaggedType.simplify tty
    end;
fun makehtml root msg = 
    let val str = TextIO.openOut (root^".html")
    in 
	TextIO.output(str,"<html><head><title>Test</title>"^bgColorScript^"</head><body>"
			  ^msg^"<br />"
                          ^"<table border='1' align='top'><tr><td>R</td><td>S</td><td>Q</td></tr> "
                          ^"<tr><td>"^(Html.htmlsToString (TaggedType2Html.tt2base(tagged_type ttyctx "tests/testr.nrc")))^"</td>"
			  ^"<td>"^(Html.htmlsToString (TaggedType2Html.tt2base(tagged_type ttyctx "tests/tests.nrc")))^"</td>"
			  
			  ^"<td>"^(Html.htmlsToString (TaggedType2Html.tt2ref(tagged_type ttyctx ("tests/"^root^".nrc"))))^"</td></tr>"
                          ^"<tr><td>"^(Html.htmlsToString (TaggedValue2Html.tv2base(tagged_query tctx "tests/testr.nrc")))^"</td>"
			  ^"<td>"^(Html.htmlsToString (TaggedValue2Html.tv2base(tagged_query tctx "tests/tests.nrc")))^"</td>"
			  
			  ^"<td>"^(Html.htmlsToString (TaggedValue2Html.tv2ref(tagged_query tctx ("tests/"^root^".nrc"))))^"</td></tr></table></body>");
	TextIO.closeOut(str)
    end
;

print "Making test7.html\n";
makehtml "test7" ("");

print "Making test8.html\n";
makehtml "test8" ("");


