functor VarFunc(val tag : string) = 
struct
  type var = string * int

  val index = ref 1
  fun fresh_tag() = 
      let val i = !index 
          val _ = index := i+1 
      in i 
      end

  fun mk_var(s) = (s,0)
      

  fun fresh_var(s) = (s,fresh_tag())
  fun fresh_anonymous_var() = (tag, fresh_tag())

  fun toString (s,i) = s ^ "$" ^ (Int.toString i)
  fun latex_var (s,i) = s ^ "_{" ^ (Int.toString i)^"}"

  fun eq((s,i),(s',i')) = i = i' andalso if i = 0 then s = s' else true

  fun compare((s,i),(s',i')) = 
      case Int.compare (i,i') 
       of LESS => LESS
	| EQUAL => 
	  String.compare(s,s')
	| GREATER => GREATER

  structure Map = ListMapFn(struct
			    type ord_key = var
			    val compare = compare
			    end);
  structure Set = ListSetFn(struct
			    type ord_key = var
			    val compare = compare
			    end);


end
